
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>获得结果 / iVAN</title>

    <meta name="description" content="获得结果 获得结果在本章中,我们来学习如何获得SQL语句的执行结果. 我们称由查询返回的一组记录为一个 结果集(result set) (或在VB中被称为recordset).检索结果通常分为以下几个步骤:确认一个结果集是否可用. 将结果集的列绑定在适当的变量上. 取得行 完成对结果集的操作后,我们必须调用SQLCloseCursor来销毁它.确认一个结果集是否可用有时在执行SQL语句后,我们就已经知道结果集是否可用了.如果执行的语句并不是返回结果集的类型,我们就知道结果集不可用了.但有时我们不太清楚使用">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">获得结果</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>获得结果<br />在本章中,我们来学习如何获得SQL语句的执行结果。</p>
<p>我们称由查询返回的一组记录为一个 结果集(result set) (或在VB中被称为recordset).检索结果通常分为以下几个步骤:<br />确认一个结果集是否可用。 将结果集的列绑定在适当的变量上。 取得行 <br />完成对结果集的操作后,我们必须调用SQLCloseCursor来销毁它.<br />确认一个结果集是否可用<br />有时在执行SQL语句后，我们就已经知道结果集是否可用了。如果执行的语句并不是返回结果集的类型,我们就知道结果集不可用了。但有时我们不太清楚使用的SQL语句是什么类型，比如说，让用户自行输入SQL语句。这时，我们必须确认是否有结果集被建立，这可以通过SQLNumResultCols函数实现。如果结果集存在，则该函数返回结果集中的列数(字段数)。语法如下:</p>
<p>SQLNumResultCols proto StatementHandle:DWORD, pNumCols:DWORD<br />StatementHandle 语句句柄 pNumCols 指向一个双字的指针，其中包含了结果集的列数。 <br />如果 pNumCols指向的值为0,那么表明结果集不存在。<br />绑定列<br />与绑定一个变量到SQL语句的参数相同,我们连接(绑定)一个变量到结果集中的某一列。这里要用到的函数是SQLBindCol，语法如下:</p>
<p>SQLBindCol proto StatementHandle:DWORD,<br />                            ColumnNumber:DWORD,<br />                            TargetType:DWORD,<br />                            TargetValuePtr:DWORD,<br />                            BufferLength:DWORD,<br />                            pStrLenOrIndPtr:DWORD<br />StatementHandle 语句句柄 ColumnNumber 结果集中要绑定的列序数.列序数从1开始.列0是书签(bookmark)列. TargetType The 指示 TargetValuePtr指向的变量(缓冲区)的类型的常数。 TargetValuePtr 指向将要捆绑到列的变量或缓冲区的指针。当调用SQLFetch来获得结果集中的行时,本参数指向的变量或缓冲区将被填入被绑定的列的值。 BufferLength 由TargetValuePtr指向的缓冲区的长度。 pStrLenOrIndPtr 参见前章SQLBindParameter <br />例子:</p>
<p>.data?<br />buffer db 21 dup(?)<br />DataLength dd ? ;调用SQLFetch后，被填入缓冲区的字符串的长度</p>
<p>.code<br />.....<br />invoke SQLBindCol, hStmt, 1, SQL_C_CHAR, addr buffer, 21, addr DataLength<br />取得一行<br />非常简单.先调用SQLFetch 检索结果集的一列到绑定的变量中。当SQLFetch调用完成,游标(cursor)被更新(updated).可以认为游标就是一个记录指针(record pointer). 它指明了SQLFetch调用后将返回哪一行。比如说,如果结果集有4列，当结果集建立时，游标指向第一行.当调用了SQLFetch 后,游标被加1。所以如果调用了SQLFetch 4次,就没有更多的行可被提交了。游标会显示指向文件尾(EOF). SQLFetch语法如下:</p>
<p>SQLFetch proto StatementHandle:DWORD</p>
<p>当没有行可提交时，这个函数返回 SQL_NO_DATA.</p>
<p>例子:</p>
<p>.data?<br />buffer db 21 dup(?)<br />DataLength dd ?</p>
<p>.code<br />.....<br />invoke SQLBindCol, hStmt, 1, SQL_C_CHAR, addr buffer, 21, addr DataLength<br />invoke SQLFetch, hStmt</p>
<p>译者废话:还记得地球的经纬吗?我们通过SQLBindCol来定位经度(列),用游标来定义纬度(行),用SQLFetch来获得坐标，而结果集就是地球。大航海时代２的同好们不应忘记呀!(船长,我们找不到水......顺便问一句,这是地球吗%$#@&amp;*^:-)</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-09 09:06:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%8f%98%e9%87%8f/" title="变量">变量</a>, <a href="https://www.iamivan.net/tag/%e7%bb%93%e6%9e%9c/" title="结果">结果</a>, <a href="https://www.iamivan.net/tag/%e8%af%ad%e5%8f%a5/" title="语句">语句</a>, <a href="https://www.iamivan.net/tag/%e6%8c%87%e5%90%91/" title="指向">指向</a>, <a href="https://www.iamivan.net/tag/%e7%bc%93%e5%86%b2%e5%8c%ba/" title="缓冲区">缓冲区</a>, <a href="https://www.iamivan.net/tag/%e6%b8%b8%e6%a0%87/" title="游标">游标</a>, <a href="https://www.iamivan.net/tag/%e7%bb%93%e6%9e%9c%e9%9b%86/" title="结果集">结果集</a>        </div> -->
	</section>
	
	

	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5Yemp.html" rel="bookmark" class="title">PHP&plus;Ajax远程图片抓取器下载的例子</a>
					<div>
						  先看效果 实现原理 发送请求 :将输入的目标网址及保存路径名称采用AJAX异步的方式发送到image.info.php文件,该文件中包含有一个ImageCatch类,注意:因为有一个是指定目标图片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqOvZz.html" rel="bookmark" class="title">Ajax基础必读&colon;AJAX中的一些关键技术</a>
					<div>
						ajax ajax架构中主要涉及的技术:client: javascript解析xml, 操纵DOM修改html页面,javascript是&quot;OO&quot;的语言.server: serv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQalWb.html" rel="bookmark" class="title">如何使文本在DIV&plus;CSS布局中垂直居中</a>
					<div>
						css DIV+CSS布局中垂直居中的实现. &lt;html&gt;&lt;head&gt;&lt;style&gt;body{TEXT-ALIGN: center;}#center{ MARGIN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLoZvM.html" rel="bookmark" class="title">豆瓣网杨勃：在越来越火的豆瓣上狂欢</a>
					<div>
						一年前,在几个朋友近二十万的集资赞助下,杨勃创办了一个名叫豆瓣的网站,口号是&quot;萝卜青菜,各有所爱&quot;,内容是书.电影.音乐,全是杨勃自己喜欢的东西. 现在,这个页面简单的豆瓣网(ww ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR5Qqb.html" rel="bookmark" class="title">PHP技巧：使用APC缓存优化PHP程序</a>
					<div>
						Alternative PHP Cache(APC)是 PHP 的一个免费公开的优化代码缓存.它用来提供免费,公开并且强健的架构来缓存和优化 PHP 的中间代码. 在 Windows 下,APC 要求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqQ2KM.html" rel="bookmark" class="title">Dll注入经典方法完整版</a>
					<div>
						Pnig0s1992:算是复习了,最经典的教科书式的Dll注入. 总结一下基本的注入过程,分注入和卸载 注入Dll: 1,OpenProcess获得要注入进程的句柄 2,VirtualAllocEx在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1l6qz.html" rel="bookmark" class="title">远程控制向Windows Server 2008设置要安全</a>
					<div>
						在规模稍微大一些的局域网工作环境中,网络管理员时常会采用远程控制方式来管理服务器或重要工作主机:虽然这种控制方式可以提高网络管理效率,但是远程控制方式带来的安全威胁往往也容易被管理人员忽视.为了保障服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNW9mb.html" rel="bookmark" class="title">教你快速学会分离带木马的文件</a>
					<div>
						第一步:用Ultraedit的十六进制方式打开绑定程序,选中第二个mz到第三个mz之间的内容(即第二个文件),将该部分复制.然后新建一个文件,粘贴,保存为exe文件. 第二步:选中第三个mz至文件末尾 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE0Kdb.html" rel="bookmark" class="title">ASP&period;NET页面的重定向</a>
					<div>
						在Response.Redirect(&quot;a.aspx&quot;)保存此页的数据后,服务器将页面直接转向到a.aspx中的一个缺陷,就是转向后会丢失此页所有的Request的参数,并且此方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91LyvM.html" rel="bookmark" class="title">PS绘制星星放射效果</a>
					<div>
						  最终效果1.在Photoshop中绘制一个星型:2.向左移动:3.为达到立体效果我们使用三种颜色: 4.制作不规则区域,填充颜色: 分类: PS入门教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Anmqp.html" rel="bookmark" class="title">巧用WPS表格下拉菜单快速录入数据</a>
					<div>
						  如果WPS表格中全部手动输入大量数据时,容易造成录入失误,浪费时间和精力.使用WPS下拉框功能,快速输入数据,可以吧帮我们节省时间.简化操作.具体操作步骤如下. 操作步骤 1.选中需要设置下拉框的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PeQ6M.html" rel="bookmark" class="title">如何为Win8&period;1&sol;Win10的文件夹加密？</a>
					<div>
						  如何为Win8.1/Win10的文件夹加密?         方法/步骤 小编就以自己ID命名的文件夹做示范 首先,新建一个文本文档 打开后准确输入以下内容 cls @ECHO OFF title ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWX1Aep.html" rel="bookmark" class="title">win7系统在任务栏添加图标后如何居中显示</a>
					<div>
						  win7系统在任务栏添加图标后如何居中显示 1.首先在桌面上新建一个文件夹,将需要居中的程序复制到该文件夹中; 2.在任务栏上单击右键,将&quot;锁定任务栏&quot;前面的勾去掉; 3.然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWAWmb.html" rel="bookmark" class="title">插件接触不良引起的电脑死机故障</a>
					<div>
						  故障问题:电脑有时无法启动,用手拍打机箱后,又可以启动,但是在运行过程中特别容易死机,是什么原因引起的,该如何排除? 故障排除 : 此故障明显是由接触不良引起的,也是比较常见的一类故障.此类故障比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkBRWb.html" rel="bookmark" class="title">Mac怎么用Beautune美化照片</a>
					<div>
						  1.Beautune 针对面,眼,嘴设计了3个独立的美化频道,再加上多样化的照片辅助修改功能,无敌了!妹子们,直接将你的玉照拖入 Beautune 即可开始编辑: 2.看以下是面部美化频道的诸多功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEW5v6p.html" rel="bookmark" class="title">什么原因导致电脑黑屏</a>
					<div>
						  分析原因:难道是病毒作怪了?不可能,还没有听说哪个病毒不让关机呢!于是再次开机,静观其变,这次发现开机时主机没有报警声,电源风扇正常,CPU风扇也正常,那是怎么回事?在没有其他办法的情况下,向朋友 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGV66p.html" rel="bookmark" class="title">php读取html并截取字符串的简单代码&lowbar;php技巧</a>
					<div>
						复制代码 代码如下: &lt;?php $title=''; $hello='jb51.net!'; $file=file_get_contents('http://www.baidu.com');  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWkR6p.html" rel="bookmark" class="title">C双向链表</a>
					<div>
						写了一个很简单的双向链表 #include &lt;stdio.h&gt; #include &lt;STDLIB.H&gt; #include &lt;MALLOC.H&gt; //一个简单链表,只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQKv7p.html" rel="bookmark" class="title">android-用户输入时间和系统输入时间不一样</a>
					<div>
						问题描述 用户输入时间和系统输入时间不一样 获取用户输入时间和日期: DatePicker dp = (DatePicker) findViewById(R.id.datePicker);TimePi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlwX7p.html" rel="bookmark" class="title">【UWP通用应用开发】控件、应用栏</a>
					<div>
						控件的属性.事件与样式资源 如何添加控件 添加控件的方式有多种,大家更喜欢下面哪一种呢? 1)使用诸如Blend for Visual Studio或Microsoft Visual Studio X ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7QrPp.html" rel="bookmark" class="title">PS为人物美白的4种方法</a>
					<div>
						原始图 下面就是四种方法哟~~快来来试试吧  (*^__^*) ... 第一个 效果很好哦 很白皙 O(∩_∩)O     第二个 会有朦胧的感觉呢!!     第三个 不一样喽 可以调出很多效果呢~ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4rWoz.html" rel="bookmark" class="title">中国的互联网和非互联网</a>
					<div>
						不管是从阳历出发还是按阴历计算,2013年终于已经过去.在这一年的中国互联网业依然是高歌猛进,可谓战绩辉煌.而根据CNNIC的最新报告,目前中国的网民规模已经达到6.18亿,全年新增了网民5358万人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRD5Paz.html" rel="bookmark" class="title">把 BPEL 流程部署到 ODE 中问题！！！！</a>
					<div>
						问题描述 我在学习bpel,在myeclipse中把BPEL流程部署到ODE中出现如下错误IWAB0381Ifile:/D:/Myeclipse_workspace6.5/HelloWorld/Hel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXq74jz.html" rel="bookmark" class="title">微信自动抢红包</a>
					<div>
						github地址 :https://github.com/linhaosheng/WeChatHongBao_Master/tree/master 微信自动抢红包,目前只适配了6.3.32版本的,在a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoxE7M.html" rel="bookmark" class="title">美女、犯案、&OpenCurlyDoubleQuote;死磕&rdquo;希拉里，黑客 Kim Dotcom 的恣意人生</a>
					<div>
						       如果在你心目中,黑客打上了&quot;死宅&quot;.&quot;沉默寡言&quot;--的标签了的话,Kim Dotcom 绝对是可以颠覆你对黑客传统印象的那一个. 在雷锋网(公众号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEK15Ap.html" rel="bookmark" class="title">《Hadoop海量数据处理：技术详解与项目实战》一导读</a>
					<div>
						前 言 Hadoop海量数据处理:技术详解与项目实战 为什么要写这本书 2013年被称为&quot;大数据元年&quot;,标志着世界正式进入了大数据时代,而就在这一年,我加入了清华大学苏州汽车研究院 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNXP5p.html" rel="bookmark" class="title">ExtJS4利根据登录后不同的角色分配不同的树形菜单&lowbar;extjs</a>
					<div>
						继续我的上一篇,设置好cookie后,将他们取出来 复制代码 代码如下: var userName = Ext.util.Cookies.get('userName'); var userAuthor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVyR3z.html" rel="bookmark" class="title">html文件中jquery与velocity变量中的&dollar;冲突的解决方法&lowbar;jquery</a>
					<div>
						问题描述: 在使用velocity模版引擎的环境下,使用jquery时,如:$.fullCalendar.gcalFeed('http://www.google.com/calendar/feeds/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEgZEz.html" rel="bookmark" class="title">Javascript 判断客户端浏览器类型代码&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;script type=&quot;text/javascript&quot;&gt; /*详细方法1*/ function CheckBrowser() { var a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm7jRp.html" rel="bookmark" class="title">Servlet中过滤器在权限中的应用</a>
					<div>
						问题描述 fdhgfsdfhsdhsdhsdhsd 解决方案 解决方案二:可以拦截所有客户端过来的url,可以先建立一张资源表(url)和角色表资源和角色绑定用户和角色绑定这样可以给每个人分配角色即权 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 10 q. 0.069 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
